package org.nakedobjects.nof.util.memento;

import org.nakedobjects.noa.adapter.Oid;
import org.nakedobjects.nof.core.util.DebugString;


class CollectionData extends Data {
    private final static long serialVersionUID = 1L;
    final Data[] elements;

    public CollectionData(final Oid oid, final String className, final Data[] elements) {
        super(oid, "", className);
        this.elements = elements;
    }

    public CollectionData(final TransferableReader data) {
        super(data);

        int no = data.readInt();
        elements = new Data[no];
        for (int i = 0; i < no; i++) {
            elements[i] = (Data) data.readObject();
        }
    }
    

    public void debug(DebugString debug) {
        super.debug(debug);
        for (int i = 0; i < elements.length; i++) {
            debug.appendln("" + i + 1, elements[i]);
            
            // TODO recurse!
        }
    }


    public String toString() {
        StringBuffer str = new StringBuffer("(");
        for (int i = 0; i < elements.length; i++) {
            str.append((i > 0) ? "," : "");
            str.append(elements[i]);
        }
        str.append(")");
        return str.toString();
    }

    public void writeData(final TransferableWriter data) {
        super.writeData(data);

        int no = elements.length;
        data.writeInt(no);
        for (int i = 0; i < no; i++) {
            data.writeObject(elements[i]);
        }
    }
}
// Copyright (c) Naked Objects Group Ltd.
