package org.nakedobjects.nof.util.memento;

/**
 * Marks an object as transferable over the network, between JVMs.
 * 
 * When you implement this interface you must provide a constructor that takes a TransferableReader. This is
 * used to recreate the object from the serialized data.
 */
public interface Transferable {
    void writeData(TransferableWriter writer);
}
// Copyright (c) Naked Objects Group Ltd.
